de.caff.generics.function

## Interface VarByteOperator

- Functional Interface:
    This is a functional interface and can therefore be used as the assignment target for a lambda expression or method reference.

      @FunctionalInterface
      public interface VarByteOperator

  Primitive byte operator with a variable number of arguments.

  Although this basically works for a variable byte array via the `apply(byte...)` method implementors have to implement the method `apply(ByteIndexable)` with a `ByteIndexable` argument. This is done to make this class generally more useful without the need to copy arrays.

  Since:
    November 03, 2020
  Author:
    Rammi

- - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `default byte` | `apply(byte... values)` Apply this operator.
    `byte` | `apply(ByteIndexable values)` Apply this operator.
    `static VarByteOperator` | `fromBinary(ByteOperator2 binaryOp, byte startValue)` Create an variable args operator from applying a binary operator over and over.

- - ### Method Detail

    - #### apply

          default byte apply(byte... values)

      Apply this operator. This default method forwards execution to `apply(ByteIndexable)`.
      Parameters:
        `values` - arguments on which this operator is applied
      Returns:
        result of applying this operator to all arguments

    - #### apply

          byte apply(@NotNull
                     ByteIndexable values)

      Apply this operator.
      Parameters:
        `values` - indexable providing the values on which this operator operates
      Returns:
        result of applying this operator to all values

    - #### fromBinary

          @NotNull
          static VarByteOperator fromBinary(@NotNull
                                                     ByteOperator2 binaryOp,
                                                     byte startValue)

      Create an variable args operator from applying a binary operator over and over.

      Eg

           VarByteOperator maxOp = VarByteOperator.fromBinary((v1, v2) -> (byte)Math.max(v1, v2), Byte.MIN_VALUE);
           byte max = maxOp.apply((byte)1, (byte)-7, (byte)-13, (byte)42);

      On each application the currently accumulated result becomes the left (first) argument of `binaryOp`, while the run value becomes the right (second).
      Parameters:
        `binaryOp` - binary operator
        `startValue` - start value (result of operator if no values are given)
      Returns:
        variable byte argument operator which applies the given binary operator over and over